CURRENT_ON = 1
CURRENT_OFF = 2
ALL_ON = 3
ALL_OFF = 4

-----------------------
--intrument menu entry
-----------------------
renoise.tool():add_menu_entry {
  name = "Instrument Box:Autoseek:Autoseek Current Instrument ON",
  invoke = function() main(CURRENT_ON)
  end
}

renoise.tool():add_menu_entry {
  name = "Instrument Box:Autoseek:Autoseek Current Instrument OFF",
  invoke = function() main(CURRENT_OFF)
  end
}

renoise.tool():add_menu_entry {
  name = "Instrument Box:Autoseek:Autoseek All Instruments ON",
  invoke = function() main(ALL_ON)
  end
}

renoise.tool():add_menu_entry {
  name = "Instrument Box:Autoseek:Autoseek All Instruments OFF",
  invoke = function() main(ALL_OFF)
  end
}

-----------------------
function main(mode)

  local song = renoise.song()
  local sel_inst = song.selected_instrument
  --------------------
  --current instrument
  --------------------
  if mode == CURRENT_ON then
    --loop samples in instrument
    for sample = 1,#sel_inst.samples do
      sel_inst.samples[sample].autoseek = true
    end
  end
  
  if mode == CURRENT_OFF then
    --loop samples in instrument
    for sample = 1,#sel_inst.samples do
      sel_inst.samples[sample].autoseek = false
    end
  end
  -------------------
  --all instruments
  -------------------
  if mode == ALL_ON then
    --loop instruments
    for inst = 1,#song.instruments do
      --loop samples in instrument
      for sample = 1,#song.instruments[inst].samples do
        song.instruments[inst].samples[sample].autoseek = true
      end
    end
  end
  
  if mode == ALL_OFF then
    --loop samples in instrument
    for inst = 1,#song.instruments do
      --loop samples in instrument
      for sample = 1,#song.instruments[inst].samples do
        song.instruments[inst].samples[sample].autoseek = false
      end
    end
  end
end
